{{
*****************************
* File jvmMonitor: monitors *
*****************************
}}

{{
  Monitors are used to obtain exclusive access to a referenced object using a lock. Because a single thread 
  can have multiple locks on a single object, careful checks are performed before granting an exclusive 
  lock. Likewise, checks are done before releasing a lock. The locking and unlocking process is handled 
  with monitors.  
  To lock an object, the monitor checks the object's status. When the object is not locked by another thread, 
  an exclusive lock is obtained. When another thread already has the object locked, the current thread waits 
  until the object is unlocked.  
  When the lock on the object is released, the monitor checks to see if this is the last lock that this thread 
  has on the object. If it is, then other threads waiting for the object are allowed to gain access to and 
  possibly lock the object. 
  Note:
  A NullPointerException is thrown instead if the referenced object is null.
}}


PUB jb_monitorenter
{{ Meaning: Enter monitored region of code. }}


PUB jb_monitorexit
{{ Meaning: Exit monitored region of code. }}
  